
#include <math.h>
#include "ph.h"

static Vertex	vertex[12];
static Trigon	trigon[20];

int	Polyhedron(ptr)
Trigon	**ptr;
{
	double	x,z,a=(sqrt(5.0)+1.0)/2.0,b=1.0/sqrt(a*a+1.0),g=a*b,
		    c=g/sqrt(g*g+(g-b)*(g-b)),s=(g-b)/sqrt(g*g+(g-b)*(g-b));
	int	v;

#define VERTEX(V,X,Y,Z)	vertex[V].x= X; vertex[V].y= Y; vertex[V].z= Z

	VERTEX( 0, -g,0.0, -b); VERTEX( 1,0.0,  b, -g);
	VERTEX( 2,0.0, -b, -g); VERTEX( 3, -b, -g,0.0);
	VERTEX( 4, -g,0.0,  b); VERTEX( 5, -b,  g,0.0);
	VERTEX( 6,  b,  g,0.0); VERTEX( 7,  g,0.0, -b);
	VERTEX( 8,  b, -g,0.0); VERTEX( 9,0.0, -b,  g);
	VERTEX(10,0.0,  b,  g); VERTEX(11,  g,0.0,  b);

	for (v=0; v<12; v++) {
	    x=vertex[v].x*c-vertex[v].z*s;
	    z=vertex[v].x*s+vertex[v].z*c; vertex[v].x=x;
					   vertex[v].z=z;
	}

#define TRIGON(T,A,B,C)	\
	trigon[T].a=vertex+A; trigon[T].b=vertex+B; trigon[T].c=vertex+C

	TRIGON( 0,0, 1, 2); TRIGON( 1,0, 2, 3);
	TRIGON( 2,0, 3, 4); TRIGON( 3,0, 4, 5);
	TRIGON( 4,0, 5, 1); TRIGON( 5,1, 5, 6);
	TRIGON( 6,1, 6, 7); TRIGON( 7,1, 7, 2);
	TRIGON( 8,2, 7, 8); TRIGON( 9,2, 8, 3);
	TRIGON(10,3, 8, 9); TRIGON(11,3, 9, 4);
	TRIGON(12,4, 9,10); TRIGON(13,4,10, 5);
	TRIGON(14,5,10, 6); TRIGON(15,6,10,11);
	TRIGON(16,6,11, 7); TRIGON(17,7,11, 8);
	TRIGON(18,8,11, 9); TRIGON(19,9,11,10);

	*ptr=trigon; return 20;
}
