
#include <math.h>
#include "ph.h"

static Vertex	vertex[6];
static Trigon	trigon[8];

int	Polyhedron(ptr)
Trigon	**ptr;
{
	double	x,y,z,s2=sqrt(2.0),s3=sqrt(3.0),s6=sqrt(6.0);
	int	v;

#define VERTEX(V,X,Y,Z)	vertex[V].x= X; vertex[V].y= Y; vertex[V].z= Z

	VERTEX(0, 0.0, 0.0,-1.0); VERTEX(1, 0.0,-1.0, 0.0);
	VERTEX(2,-1.0, 0.0, 0.0); VERTEX(3, 0.0, 1.0, 0.0);
	VERTEX(4, 1.0, 0.0, 0.0); VERTEX(5, 0.0, 0.0, 1.0);

	for (v=0; v<6; v++) {
	    x=( vertex[v].x+vertex[v].y-vertex[v].z*2.0)/s6;
            y=(-vertex[v].x+vertex[v].y		       )/s2;
            z=( vertex[v].x+vertex[v].y+vertex[v].z    )/s3; vertex[v].x=x;
							     vertex[v].y=y;
							     vertex[v].z=z;
	}

#define TRIGON(T,A,B,C)	\
	trigon[T].a=vertex+A; trigon[T].b=vertex+B; trigon[T].c=vertex+C

	TRIGON(0,0,1,2); TRIGON(1,0,2,3); TRIGON(2,0,3,4); TRIGON(3,0,4,1);
	TRIGON(4,1,4,5); TRIGON(5,1,5,2); TRIGON(6,2,5,3); TRIGON(7,3,5,4);

	*ptr=trigon; return 8;
}
